Index: /main/trunk/model-sites-dev/mars/collect/cosi-slac/BUILDCOL.sh
===================================================================
--- /main/trunk/model-sites-dev/mars/collect/cosi-slac/BUILDCOL.sh	(revision 30434)
+++ /main/trunk/model-sites-dev/mars/collect/cosi-slac/BUILDCOL.sh	(revision 30434)
@@ -0,0 +1,3 @@
+#!/bin/bash
+
+buildcol.pl -removeold -site localsite $* cosi-slac
Index: /main/trunk/model-sites-dev/mars/collect/cosi-slac/IMPORT.sh
===================================================================
--- /main/trunk/model-sites-dev/mars/collect/cosi-slac/IMPORT.sh	(revision 30434)
+++ /main/trunk/model-sites-dev/mars/collect/cosi-slac/IMPORT.sh	(revision 30434)
@@ -0,0 +1,3 @@
+#!/bin/bash
+
+import.pl -removeold -site localsite $* cosi-slac
Index: /main/trunk/model-sites-dev/mars/collect/cosi-slac/etc/collectionConfig.xml
===================================================================
--- /main/trunk/model-sites-dev/mars/collect/cosi-slac/etc/collectionConfig.xml	(revision 30434)
+++ /main/trunk/model-sites-dev/mars/collect/cosi-slac/etc/collectionConfig.xml	(revision 30434)
@@ -0,0 +1,304 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<CollectionConfig xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+  <metadataList>
+    <metadata lang="en" name="creator"></metadata>
+    <metadata lang="en" name="maintainer"></metadata>
+    <metadata lang="en" name="public">true</metadata>
+  </metadataList>
+  <displayItemList>
+    <displayItem assigned="true" lang="en" name="name">cosi-slac</displayItem>
+    <displayItem assigned="true" lang="en" name="description">
+      &lt;p&gt;
+        This collection shows the capabilities of 
+        &lt;a href="http://jmir.sourceforge.net/jAudio.html"&gt;jAudio&lt;/a&gt; 
+        and 
+        &lt;a href="http://jmir.sourceforge.net/jSongMiner.html"&gt;jSongMiner&lt;/a&gt;
+        in combination with Greenstone3, based on the 
+        250 MP3 files from the 
+        &lt;a href="http://jmir.sourceforge.net/Codaich.html"&gt;SLAC&lt;/a&gt;
+        (Symbolic Lyrical Audio Cultural) dataset which&#x2014;broadly speaking&#x2014;spans
+        5 broad genre, with 50 examples of each:
+        &lt;ul&gt;
+          &lt;li&gt;Modern Blues and Traditional Blues; 
+          &lt;li&gt;Baroque and Romantic; 
+          &lt;li&gt;Bebop and Swing; 
+          &lt;li&gt;Hardcore Rap and Pop Rap; and 
+          &lt;li&gt;Alternative Rock and Metal.
+        &lt;/ul&gt;
+      &lt;/p&gt;
+
+      &lt;p&gt;
+        When the digital library collection is built, jAudio is used to compute 
+	a range of audio fetures commonly
+	used in the field of Music Information Retrieval (MIR).  These features are bound to
+	the document in the digital library correspondig to the source MP3 file.  Similarly,
+	jSongMiner is used to undertake audio-fingerprinting of the source MP3 files, and
+	seek out matches at sites such as LastFM and EchoNest.  Again, the results of
+	this process (a rich set of metadata about a song) is bound into the digital
+	library collection.	
+      &lt;/p&gt;
+
+    </displayItem>
+  </displayItemList>
+  <search type="lucene">
+    <level name="document">
+      <displayItem lang="en" name="name">document</displayItem>
+    </level>
+    <level name="section">
+      <displayItem lang="en" name="name">section</displayItem>
+    </level>
+    <defaultLevel name="document"/>
+    <index name="text">
+      <displayItem lang="en" name="name">text</displayItem>
+    </index>
+    <index name="Title">
+      <displayItem lang="en" name="name">titles</displayItem>
+    </index>
+    <index name="Source">
+      <displayItem lang="en" name="name">filenames</displayItem>
+    </index>
+    <defaultIndex name="text"/>
+    <searchType name="plain"/>
+    <searchType name="simpleform"/>
+    <searchType name="advancedform"/>
+    <format>
+      <gsf:template match="documentNode">
+	<td valign="top">
+	  <gsf:link type="document">
+	    <gsf:icon type="document"/>
+	  </gsf:link>
+	</td>
+	<td>
+	  <gsf:switch>
+	    <gsf:metadata name="Title" select="ancestors" separator=": "/>
+	    <gsf:when test="exists">
+	      <gsf:metadata name="Title" select="ancestors" separator=": "/>:
+	    </gsf:when>
+	  </gsf:switch>
+	  <gsf:link type="document">
+	    <gsf:metadata name="Title"/>
+	  </gsf:link>
+	</td>
+      </gsf:template>
+    </format>
+  </search>
+  <infodb type="jdbm"/>
+  <import>
+    <pluginList>
+      <plugin name="ZIPPlugin"/>
+      <plugin name="GreenstoneXMLPlugin"/>
+
+      <plugin name="EmbeddedMetadataPlugin"/>
+
+      <plugin name="MusicIRPlugin">
+          <option name="-compute_mir_features" value="true"/>
+          <option name="-retrieve_mir_metadata" value="true"/>
+          <option name="-enable_cache"/>
+      </plugin>
+
+      <plugin name="TextPlugin"/>
+      <plugin name="HTMLPlugin"/>
+      <plugin name="EmailPlugin"/>
+      <plugin name="PDFPlugin"/>
+      <plugin name="RTFPlugin"/>
+      <plugin name="WordPlugin"/>
+      <plugin name="PostScriptPlugin"/>
+      <plugin name="PowerPointPlugin"/>
+      <plugin name="ExcelPlugin"/>
+      <plugin name="ImagePlugin"/>
+      <plugin name="ISISPlugin"/>
+      <plugin name="NulPlugin"/>
+      <plugin name="MetadataXMLPlugin"/>
+      <plugin name="ArchivesInfPlugin"/>
+      <plugin name="DirectoryPlugin"/>
+    </pluginList>
+  </import>
+  <browse>
+    <classifier name="List">
+      <option name="-metadata" value="dc.Title;Title"/>
+      <option name="-partition_type_within_level" value="approximate_size"/>
+    </classifier>
+    <classifier name="AZCompactList">
+      <option name="-metadata" value="dc.Type.genre"/>
+      <option name="-buttonname" value="Genre"/>
+    </classifier>
+    <format>
+      <gsf:template match="documentNode">
+	<td valign="top">
+	  <gsf:link type="document">
+	    <gsf:icon type="document"/>
+	  </gsf:link>
+	</td>
+	<td valign="top">
+	  <gsf:metadata name="srclink"/>
+	  <gsf:choose-metadata>
+	    <gsf:metadata name="thumbicon"/>
+	    <gsf:metadata name="srcicon"/>
+	  </gsf:choose-metadata>
+	  <gsf:metadata name="/srclink"/>
+	</td>
+	<td valign="top">
+	  <gsf:choose-metadata>
+	    <gsf:metadata name="dc.Title"/>
+	    <gsf:metadata name="exp.Title"/>
+	    <gsf:metadata name="Title"/>
+	    <gsf:default>Untitled</gsf:default>
+	  </gsf:choose-metadata>
+	  <gsf:switch>
+	    <gsf:metadata name="Source"/>
+	    <gsf:when test="exists">
+	      <br/>
+	      <i>(<gsf:metadata name="Source"/>)</i>
+	    </gsf:when>
+	  </gsf:switch>
+	</td>
+      </gsf:template>
+      <gsf:template match="classifierNode">
+	<td valign="top">
+	  <gsf:link type="classifier">
+	    <gsf:icon type="classifier"/>
+	  </gsf:link>
+	</td>
+	<td valign="top">
+	  <gsf:metadata name="srclink"/>
+	  <gsf:choose-metadata>
+	    <gsf:metadata name="thumbicon"/>
+	    <gsf:metadata name="srcicon"/>
+	  </gsf:choose-metadata>
+	  <gsf:metadata name="/srclink"/>
+	</td>
+	<td valign="top">
+	  <gsf:choose-metadata>
+	    <gsf:metadata name="dc.Title"/>
+	    <gsf:metadata name="exp.Title"/>
+	    <gsf:metadata name="Title"/>
+	    <gsf:default>Untitled</gsf:default>
+	  </gsf:choose-metadata>
+	  <gsf:switch>
+	    <gsf:metadata name="Source"/>
+	    <gsf:when test="exists">
+	      <br/><i>(<gsf:metadata name="Source"/>)</i>
+	    </gsf:when>
+	  </gsf:switch>
+	</td>
+      </gsf:template>
+      <gsf:template match="classifierNode" mode="horizontal">
+	<gsf:link type="horizontal">
+	  <gsf:metadata name="Title"/>
+	</gsf:link>
+      </gsf:template>
+    </format>
+  </browse>
+  <display>
+    <format>
+      <gsf:option name="TOC" value="false"/>
+
+  <xsl:template name="documentContent">
+
+    <xsl:variable name="httpCollection"><xsl:value-of select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/></xsl:variable>
+
+    <xsl:variable name="assocFilePath"><gsf:metadata name="assocfilepath" select="root"/></xsl:variable>
+
+    <xsl:variable name="lastfmtrackurl">
+      <gsf:metadata name="dc.Identifier.lastfmtrackurl"/>
+    </xsl:variable>
+
+    <xsl:variable name="echonestid">
+      <gsf:metadata name="dc.Identifier"/>
+    </xsl:variable>
+
+    <div class="documenttext"> 
+
+<table>
+  <tbody>
+    <tr style="background-color:#afa">
+      <td>
+	  Title
+      </td>
+      <td>
+	  <gsf:metadata name="dc.Title"/>
+      </td>
+    </tr>
+
+    <tr style="background-color:#ffa">
+	<td>Album Title</td>
+        <td><gsf:metadata name="dc.Title.albumtitle"/></td>
+    </tr>
+
+    <tr style="background-color:#afa">
+	<td>Artist</td>
+        <td><gsf:metadata name="dc.Creator"/></td>
+    </tr>
+
+    <tr style="background-color:#ffa" valign='top'>
+	<td>Artist Summary</td>
+        <td><i><gsf:metadata name="LastFM.LastFMArtistWikiSummary"/></i></td>
+    </tr>
+
+    <tr style="background-color:#afa">
+	<td>Identifier</td>
+        <td>
+             <gsf:metadata name="dc.Identifier"/><br />
+
+             <xsl:copy-of select="$lastfmtrackurl"/><br />
+             (<a href="{$lastfmtrackurl}" target="#lastfm">Visit @ LastFM</a>)
+        </td>
+    </tr>
+
+    <tr style="background-color:#ffa">
+	<td>jAudio Features</td><td><a href="{$httpCollection}/index/assoc/{$assocFilePath}/jaudio.xml">download ACE XML feature values file</a></td>
+    </tr>
+
+    <tr style="background-color:#afa">
+	<td>jSongMiner Metadata</td><td><a href="{$httpCollection}/index/assoc/{$assocFilePath}/jsongminer.xml">download ACE XML classifications file</a></td>
+    </tr>
+
+
+
+
+  </tbody>
+</table>
+
+    </div>
+  </xsl:template>
+
+
+    </format>
+
+  </display>
+
+
+  <replaceListRef id="gs2-standard"/>
+  <serviceRackList>
+    <!-- comment out the following serviceRack if you want to disable OAI for this collection -->
+    <serviceRack name="OAIPMH">
+      <ListMetadataFormats>
+	<!--What metadata sets to support is collection specific. To support other metadata schema, simply add a metadataFormat element here.
+	The support of unqualified Dublin Core metadata set is mandatory in the oai specification.
+	-->
+	<metadataFormat metadataPrefix="oai_dc">
+	  <metadataPrefix>oai_dc</metadataPrefix>
+	  <schema>http://www.openarchives.org/OAI/2.0/oai_dc.xsd</schema>
+	  <metadataNamespace>http://www.openarchives.org/OAI/2.0/oai_dc/</metadataNamespace>
+	  <!--<metadataElements>dc.Title,dc.Creator,dc.Subject,dc.Description,dc.Publisher,dc.Contributor,dc.Date,dc.Type,dc.Format,dc.Identifier,dc.Source,dc.Language,dc.Relation,dc.Coverage,dc.Rights</metadataElements>              
+	  -->
+	  <mappingList>
+	    <!-- 
+	    The mapping is in the form: <publicly supported metadata name>,<mapped metadata name>, short as <A>,<B> 
+	    The first metadata name is medatory; if there is no mapped name followed, then the first name must be used by the records and
+	    searchable in the database, otherwise it is the mapped name stored in the database. The number of mapping elements matches the
+	    number of external metadata of the records. If only one name is present, the returned metadata will use this name plus the retrieved value;
+	    if both <A>,<B> are present, the returned metadata will use <A>'s name plus <B>'s value retrieved from database.
+	    
+	    **Bear in mind: if this mapping list is not present, the standard dc. metadata names (15 in total) will be used to retrieve metadata in the database.
+	    
+	    **The only case when this mapping is not present is that: 1. this metadata format is oai_dc; 2. the metadata is also stored in the database by Dublin Core's names.
+	    -->
+	    <mapping>dc.Title,Title</mapping>
+	    <!-- This mapping example means that the dc.Title is requested and the value of the metadata Title, which is used in this repository, is returned as response. -->
+	  </mappingList>
+	</metadataFormat>
+      </ListMetadataFormats>
+    </serviceRack> 
+  </serviceRackList>
+</CollectionConfig>